/**********
 * Copyright (c) 2003-2004 Greg Parker.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY GREG PARKER ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **********/

#include "includes.h"
#include "pce.h"
#include "armstubs.h"

static MemHandle armH = NULL;

int init_arm(void)
{
    if (!armH) {
        // initialize ARM code resource
        armH = DmGetResource('armc', 1000);
        if (!armH) {
            return 0;
        }
    }
    return 1;
}

uint32_t dispatch_to_arm(uint32_t fn, pace_globals *globals, uint32_t *param, int paramCount)
{
    MemPtr armP;
    uint32_t result;
    pace_args *args; // Do NOT make this static. Re-entrant ARM usage will cause a crash. fixme might be able to make stack-allocated if alignment is ok
    int i;
    
    armP = MemHandleLock(armH);

    args = arena_malloc(sizeof(*args));
    args->globals = globals;
    args->fn = fn;
    for (i = 0; i < paramCount; i++) {
        args->param[i] = param[i];
    }
    result = PceNativeCall((NativeFuncType *)armP, args);
    MemHandleUnlock(armH);
    arena_free(args);
    return result;
}
